# SIRS: Funktion der Infizierten, Gesunden und Resistenten


import matplotlib.pyplot as plt


# Ableitungsfunktion der Gesunden
def Gesunde (S, I, R, N, status):
	return - status["a"] * S * I + status["c"] * R - status["d"] * S + status["d"] * N
	

# Ableitungsfunktion der Infizierten
def Infizierte(I, S, status):
	return status["a"] * I * S - status["b"] * I - status["d"] * I


# Ableitungsfunktionen der Resistenten
def Resistente(I, R, status):
	return status["b"] * I - status["c"] * R - status["d"] * R


# Berechnung der Funktionswerte zu allen Zeiten	
def Funkwerte(status):
	t = status["t_min"]
	dt = status["schrittweite"]
	I = status["startwert_inf"]
	S = status["N"] - I
	R = 0
	N = status["N"]
	ts = [t]
	Is = [I]
	Ss = [S]
	Rs = [R]
	Ns = [N]
	
	while t <= status["t_max"]:
		t += dt
		ts.append(t)
		I += Infizierte(I, S, status) * dt
		S += Gesunde(S, I, R, N, status) * dt
		R += Resistente (I, R, status) * dt
		N = I + S + R
		Is.append(I)
		Ss.append(S)
		Rs.append(R)
		Ns.append(N)
	return ts, Is, Ss, Rs, Ns
		
	
if __name__ == "__main__":
	status = {"N": 100,"startwert_inf": 1, "t_min": 0, "t_max": 100, "schrittweite": 0.001, "a": 0.01, "b": 0.1, "c": 0.01, "d": 0.001}
	ts, Is, Ss, Rs, Ns = Funkwerte(status)
	plt.plot(ts,Is)
	plt.plot(ts,Ss)
	plt.plot(ts,Rs)
	plt.plot(ts,Ns)
	plt.show()		
	
