#Achsenverbesserung

from mpl_toolkits.axes_grid.axislines import SubplotZero
import matplotlib.pyplot as plt
import numpy as np
import math as m


def Achsenkonstruktion(N):

	fig = plt.figure()
	ax = SubplotZero(fig, 111)
	fig.add_subplot(ax)
	
	y_list = []
	schrittweite = 10**(len(str(N)) - 2) * int(str(N)[0])
		 
	for i in range(0, N+1, schrittweite):								# die Y-Achse soll sich anpassen
		y_list.append(i)
	plt.yticks(y_list)
	
	
	for direction in ["xzero", "yzero"]:								# x-Achse und y-Achse werden angezeigt-> allerdings ist die Schrift bei der y-Achse unguenstig
		ax.axis[direction].set_axisline_style("-|>")
		ax.axis[direction].set_visible(True)

	for direction in ["left", "right", "bottom", "top"]:				# "Box" wird nicht angezeigt 
		ax.axis[direction].set_visible(False)

	return ax, fig, N
	
def Myplot(twerte, ys, N, l):
	'''t_werte: Liste oder Array der x-Werte
	ys: Liste von Listen von y-Werten verschiedener Groesse
	'''
	c = 0
	ax, fig, N = Achsenkonstruktion(N)	
								# Funktion muss aufgerufen werden, damit Variablen global sind
	for y in ys:	
		# print twerte.shape	
		# print len(y)														
		plt.scatter(twerte, y, s = 10, label = l[c])								# die x- und y-Werte werden aufgerufen, dazu kommt noch die Legende
		c += 1
	plt.legend()
	ax.axis["xzero"].label.set_text("t in d")
	ax.axis["yzero"].label.set_text("Anzahl der Menschen")
	#ax.set_xlabel("t in d")
	#ax.set_ylabel("Menschen")
	#plt.ylabel("Menschen")											# die Legende wird zum Graphen hinzugefuegt
	#plt.xlabel("t in d")
	ax.grid(True)
	plt.show()
	
if __name__ == "__main__":
	x = np.arange(0, 100, 0.1)
	y = 1000 * np.sin(x)												# Beispielfunktionen
	b = x**2	
	Myplot(x, [y,b], 10000, ["Funktion 1", "Funktion 2"])

