import numpy as np
import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, Button, RadioButtons


import achsenFertig_diskret_mit_Label
import sirs_dynamisch_letal_diskret_hp
import sirs_dynamisch_letal_funktionen_diskret_np as rechne

gesamtzahl=100#anzahl=10000
delta_gesamtzahl= 1#delta_anzahl=1.0
infiziert_start=1
delta_infiziert_start=1.0
t_max = 100
delta_t_max=1
a = 0.99
delta_a=0.001
b = 0.99
delta_b = 0.001
c=0.99
delta_c=0.001
d=0.99
delta_d=0.001
e=0.99
delta_e=0.001
f=0.99
delta_f=0.001
# Dictionary fuer die festen Werte der Berechnung
status = {"N" : gesamtzahl, "startwert_inf" : infiziert_start, "t_min" : 0, "t_max" : t_max, "schrittweite" : 0.001, "a" : a, "b" : b, "c":c, "d":d, "e":e, "f":f}

axcolor = 'lightgoldenrodyellow'
#def Sliderkonstruktion(gesamtzahl, delta_gesamtzahl, 
axgesamtzahl=plt.axes([0.25,0.1,0.65,0.03], facecolor=axcolor)
sgesamtzahl=Slider(axgesamtzahl, "Startmenge aller Menschen", 0, status["N"], valinit=gesamtzahl, valstep=delta_gesamtzahl)
axinfiziert_start=plt.axes([0.25,0.2,0.65,0.03], facecolor=axcolor)
sinfiziert_start=Slider(axinfiziert_start, "Anteil an Infizierten", 0, 1., valinit=infiziert_start/(1.*gesamtzahl), valstep=(delta_infiziert_start/gesamtzahl))
axt_max=plt.axes([0.25,0.3,0.65,0.03], facecolor=axcolor)
st_max=Slider(axt_max, "Ende des Beobachtungszeitraums", 0, status["t_max"], valinit=t_max, valstep=delta_t_max)
axa=plt.axes([0.25,0.4,0.65,0.03], facecolor=axcolor)
sa=Slider(axa, "Infektionsrate", 0, status["a"], valinit=0.01, valstep=delta_a)
axb = plt.axes([0.25,0.5,0.65,0.03], facecolor=axcolor)
sb = Slider(axb, "Gesundungsrate", 0, status["b"], valinit=0.1, valstep=delta_b)
axc =plt.axes([0.25,0.6,0.65,0.03], facecolor=axcolor)
sc = Slider(axc, "Resistenzverlustrate", 0, status["c"], valinit=0.01, valstep=delta_c)
axd = plt.axes([0.25,0.7,0.65,0.03], facecolor=axcolor)
sd=Slider(axd, "Natuerliche Sterberate", 0,status["d"], valinit=0.1, valstep=delta_d)
axe =plt.axes([0.25,0.8,0.65,0.03], facecolor=axcolor)
se =Slider(axe, "Geburtenrate", 0, status["e"], valinit=0.1, valstep=delta_e)
axf=plt.axes([0.25, 0.9, 0.65, 0.03], facecolor=axcolor)
sf=Slider(axf, "Krankheitsbedingte Sterberate", 0, status["f"], valinit=0.15, valstep=delta_f)


def update(val):
	status["N"]=sgesamtzahl.val
	status["infiziert_start"]=int(sinfiziert_start.val*sgesamtzahl.val)
	print("Status inf.", status["infiziert_start"])
	status["t_max"]=st_max.val
	status["a"]=sa.val
	status["b"] = sb.val
	status["c"]=sc.val
	status["d"]=sd.val
	status["e"]=se.val
	status["f"]=sf.val
	# schoenere Achsen mit besserer Beschriftung
	print("bin in update Funktion")
	#x, fig, N = achsenFertig_diskret_mit_Label.Achsenkonstruktion(status["N"])
	# Aufruf der Funktionen und Plotten
	twerte, Iwerte, Swerte, Rwerte, Nwerte = rechne.Funkwerte (status)
	#plt.scatter(twerte, Iwerte)
	#plt.scatter(twerte, Swerte)
	print(len(twerte)==len(Iwerte))
	achsenFertig_diskret_mit_Label.Myplot(twerte, [Iwerte, Swerte, Rwerte, Nwerte], gesamtzahl, ["Infizierte", "Gesunde", "Resistente", "Gesamtzahl aller Menschen"])
	#sirs_dynamisch_letal_diskret_hp(gesamtzahl, infiziert_start, t_max, a, b, c, d, e, f)
	plt.pause(0.001) 
	plt.draw()
plt.draw()
    
#sb.on_changed(update)
#sa.on_changed(update)
#sc.on_changed(update)
#sd.on_changed(update)
#se.on_changed(update)
#sf.on_changed(update)
#sinfiziert_start.on_changed(update)
#sgesamtzahl.on_changed(update)
#if sgesamtzahl.on_changed == True:
#	pass
resetax = plt.axes([0.8, 0.025, 0.1, 0.04])
button = Button(resetax, 'Reset', color=axcolor, hovercolor='0.975')


Executeax = plt.axes([ 0.25, 0.025, 0.2, 0.04])
executeButton = Button(Executeax, "Ausfuehren", color=axcolor, hovercolor="0.975")

#def execute(event):
	#update
executeButton.on_clicked(update)#execute)
def reset(event):
    sb.reset()
    sa.reset()
    sanzahl.reset()
    st_max.reset()
    sinfiziert_start.reset()
button.on_clicked(reset)




def colorfunc(label):
    l.set_color(label)
    fig.canvas.draw_idle()


#plt.ion()
plt.show()
while True:
	pass
