# dynamisches SIRS mit Geburten- != Sterberate: Funktion der Infizierten, Gesunden und Resistenten
# Krankheit letal



# Ableitungsfunktion der Gesunden
def Gesunde (S, I, R, N, status):
	return - status["a"] * S * I + status["c"] * R - status["d"] * S + status["e"] * N
	

# Ableitungsfunktion der Infizierten
def Infizierte(I, S, status):
	return status["a"] * I * S - status["b"] * I - status["d"] * I - status["f"] * I


# Ableitungsfunktionen der Resistenten
def Resistente(I, R, status):
	return status["b"] * I - status["c"] * R - status["d"] * R


# Berechnung der Funktionswerte zu allen Zeiten	
def Funkwerte(status):
	t = status["t_min"]
	dt = status["schrittweite"]
	I = status["infiziert_start"]
	R = 0
	S = status["N"] - I -R
	
	N = status["N"]
	ts = [t]
	Is = [I]
	Ss = [S]
	Rs = [R]
	Ns = [N]
	while t <= status["t_max"]:
		t += dt
		I += Infizierte(I, S, status) * dt
		S += Gesunde(S, I, R, N, status) * dt
		R += Resistente (I, R, status) * dt
		N = I + S + R
		if round(t, 2) % 1 == 0:
			ts.append(t)
			Is.append(round(I))
			Ss.append(round(S))
			Rs.append(round(R))
			Ns.append(N)
	return ts, Is, Ss, Rs, Ns
		
	
if __name__ == "__main__":
	
	import matplotlib.pyplot as plt

	status = {"N": 100,"startwert_inf": 1, "t_min": 0, "t_max": 100, "schrittweite": 0.001, "a": 0.01, "b": 0.1, "c": 0.01, "d": 0.001, "e": 0.002}
	ts, Is, Ss, Rs, Ns = Funkwerte(status)
	plt.plot(ts,Is)
	plt.plot(ts,Ss)
	plt.plot(ts,Rs)
	plt.plot(ts,Ns)
	plt.show()		
	
