# SIS: Funktion der Infizierten und Gesunden


import matplotlib.pyplot as plt


# Ableitungsfunktion der Gesunden
def Gesunde (S, I, status):
	return -status["a"]*S*I+status["b"]*I
	

# Ableitungsfunktion der Infizierten
def Infizierte(I, S, status):
	return status["a"]*I*S-status["b"]*I
	

# Berechnung der Funktionswerte zu allen Zeiten	
def Funkwerte(status):
	t = status["t_min"]
	dt = status["schrittweite"]
	I = status["startwert_inf"]
	S = status["N"]-I
	Is = [I]
	Ss = [S]
	ts = [0]
	while t <= status["t_max"]:
		t += dt
		ts.append(t)
		I += Infizierte(I, S, status)*dt
		S += Gesunde(S, I, status)*dt
		Is.append(I)
		Ss.append(S)
	return ts, Is, Ss
		
	
if __name__ == "__main__":
	status = {"N" : 100,"startwert_inf" : 1, "t_min" : 0, "t_max" : 100, "schrittweite" : 0.001, "a" : 0.01, "b" : 0.1}
	ts, Is,Ss = Funkwerte (status)
	plt.plot(ts,Is)
	plt.plot(ts,Ss)
	plt.show()		
	
